#!/usr/bin/perl -w
#
# GTKSubEditor
#
# gss_callbacks.pl
# Callbacks to interface and some interface parts.
#
# Copyright (c) 2005 Joni Valtanen
# GNU General Public Licence v2
#

use Glib qw(TRUE FALSE);
use strict;

$main::prefs_adj_mplayer=0;
@main::subtitles = ();

$main::import_fps=25;
$main::use_mplayer=1;

$main::import_filename="/tmp/gsubeditor-imported.sub";
$main::tmp_filename="/tmp/gsubeditor-tmp1.sub";
$main::tmp2_filename="/tmp/gsubeditor-tmp2.sub";
$main::tmp3_filename="/tmp/gsubeditor-tmp3.sub";
$main::orig_filename="";
$main::tmp_col=0;
$main::lines=0;


sub readFileToCList
  {
    my (@rfdata) = @_;

    my $fn = $rfdata[0][0]; #filename
    my $model = $rfdata[0][1]; #model
    print "$fn\n";
    my $i=0;


    @main::subtitles = ();
    $model->clear;

    open IFILE, "$fn" or die("Couldn't open $fn\n") ;
    while ($main::test = readline(IFILE)) {
      $main::line = $main::test;
      @main::line_t1 = split(/}/, $main::line);
      @main::line_t2 = split(/{/, $main::line_t1[0]);
      @main::line_t3 = split(/{/, $main::line_t1[1]);
      @main::line_t4 = split(/\r/,$main::line_t1[2]);

      $main::substart[$i] = $main::line_t2[1];
      $main::substop[$i] = $main::line_t3[1];
      $main::subs[$i++] = $main::line_t4[0];
    }
    $main::lines=$i;

    $i=0;
    #	while($main::substart[$i])
    while ($i < $main::lines) {
      #	   $main::clist_subs->append( ($main::substart[$i], $main::substop[$i], $main::subs[$i] ));
      #	    push @main::subtitles,     { start => $main::substart[$i], end=> $main::substop[$i], subtitle => $main::subs[$i], },;
      $main::subtitles[$i]{start} = $main::substart[$i];
      $main::subtitles[$i]{end} = $main::substop[$i];
      $main::subtitles[$i]{subtitle} = $main::subs[$i];

      $model->set ($model->append,
			 0, $main::substart[$i],
			 1, $main::substop[$i],
			 2, $main::subs[$i],
			 3, TRUE,
			);
      #  print "{$main::substart[$main::i]}{$main::substop[$main::i]}$main::subs[$main::i]\n";
      $i++;
    }
    close(IFILE);
    $rfdata[0][2]->set_sensitive(1); #    $button_shift_shift->set_sensitive(1);
    $rfdata[0][3]->set_sensitive(1); #    $button_convert_convert->set_sensitive(1);

  }

sub quitProgram
  {
    my ($widget, $window) = @_;
    $window->destroy;
    return 0;
  }

sub delete_event
  {
    my ($window) = @_;
    $window->destroy;
    return TRUE;

  }


sub cell_edited {
  my ($cell, $path_string, $new_text, @cell_data) = @_;

  my $model = $cell_data[0][0];
  my $button_all_apply = $cell_data[0][1];

  my $path = Gtk2::TreePath->new_from_string ($path_string);
  my $column = $cell->get_data ("column");
  my $iter = $model->get_iter ($path);

  $button_all_apply->set_sensitive(1);

  if ($column == 0) {
    my $i = ($path->get_indices)[0];
    $main::subtitles[$i]{start} = $new_text;
    $model->set ($iter, $column, $main::subtitles[$i]{start});

  } elsif ($column == 1) {
    my $i = ($path->get_indices)[0];
    $main::subtitles[$i]{end} = $new_text;
    $model->set ($iter, $column, $main::subtitles[$i]{end});
  } elsif ($column == 2) {
    my $i = ($path->get_indices)[0];
    $main::subtitles[$i]{subtitle} = $new_text;
    $model->set ($iter, $column, $main::subtitles[$i]{subtitle});
  }
}

sub fileOpenOK
  {
    my ($widget, @fook_data) = @_;
    my @rftcl_data;

    my $file_dialog=$fook_data[0][0];
    my $menuitem_edit_join=$fook_data[0][6];
    my $table_split=$fook_data[0][7];

    # gots selected file
    $main::filename = $file_dialog->get_filename();
    $file_dialog->destroy();

    $main::orig_filename = $main::filename;

    $fook_data[0][5]->set_text($main::filename);

    $rftcl_data[0]=$main::filename;
    $rftcl_data[1]=$fook_data[0][2];
    $rftcl_data[2]=$fook_data[0][3];
    $rftcl_data[3]=$fook_data[0][4];

    &readFileToCList(\@rftcl_data);
    $menuitem_edit_join->set_sensitive(1);
    $table_split->set_sensitive(1);
    return 0;
  }

sub fileImportOK
  {
    my ($widget, @fiok_data) = @_;
    my @rftcl_data;
    my $line;
    my $pwd=$ENV{'PWD'};
    my $file_dialog=$fiok_data[0][0];
    my $menuitem_edit_join=$fiok_data[0][6];
    my $table_split=$fiok_data[0][7];

    print "$pwd";

    # gots selected file
    $main::filename = $file_dialog->get_filename();
    $file_dialog->destroy();

    chdir "/tmp";
    system("mplayer /dev/zero -rawvideo on:pal:fps=$main::importfps -vc null -vo null -noframedrop -benchmark -sub \"$main::filename\" -dumpmicrodvdsub&");
    system("sleep 1 && killall mplayer");
    system("mv ./dumpsub.txt $main::import_filename");
    chdir "$pwd";
    $main::filename = $main::import_filename;
    $main::orig_filename = $main::filename;
    $fiok_data[0][5]->set_text($main::filename); # $main::label_filename

    $rftcl_data[0]=$main::filename;
    $rftcl_data[1]=$fiok_data[0][2];
    $rftcl_data[2]=$fiok_data[0][3];
    $rftcl_data[3]=$fiok_data[0][4];

    &readFileToCList(\@rftcl_data);
    $menuitem_edit_join->set_sensitive(1);;
    $table_split->set_sensitive(1);

    return 0;
  }

sub fileSaveOK
  {
    my ($widget, $file_dialog) = @_;

    # gots selected file
    $main::filename = $file_dialog->get_filename();
    $file_dialog->destroy();

    $main::orig_filename = $main::filename;
    system("cp $main::tmp_filename \"$main::filename\"");

    return 0;
  }

sub fileReread
  {
    my ($widget, @fr_data) = @_;
    my @rftcl_data;

    $main::filename=$main::orig_filename;
    $rftcl_data[0]=$main::filename;
    $rftcl_data[1]=$fr_data[0][1];
    $rftcl_data[2]=$fr_data[0][2];
    $rftcl_data[3]=$fr_data[0][3];

    &readFileToCList(\@rftcl_data);
    return 0;
  }

sub fileC
  {
    my ($widget, $file_dialog) = @_;

    # gots selected file
    $file_dialog->destroy();

    return 0;
  }

sub fileOpen
  {
    my ($widget, @fo_data) = @_;

    my @fook_data;
    my $file_dialog;

    $file_dialog = new Gtk2::FileSelection("Open subtitle");
    $file_dialog->complete( "*.sub" );

    $fook_data[0]=$file_dialog;
    $fook_data[1]=$fo_data[0][0];
    $fook_data[2]=$fo_data[0][1];
    $fook_data[3]=$fo_data[0][2];
    $fook_data[4]=$fo_data[0][3];
    $fook_data[5]=$fo_data[0][4];
    $fook_data[6]=$fo_data[0][5];
    $fook_data[7]=$fo_data[0][6];

    $file_dialog->ok_button->signal_connect( "clicked", \&fileOpenOK, \@fook_data );
    $file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

    $file_dialog->show();

    return 0;
  }

sub fileImport
  {
    my ($widget, @fi_data) = @_;
    my @fiok_data;
    my $file_dialog;
    $file_dialog = new Gtk2::FileSelection("Import subtitle");
    $file_dialog->complete( "*.[srt|sub]" );

    $fiok_data[0]=$file_dialog;
    $fiok_data[1]=$fi_data[0][0];
    $fiok_data[2]=$fi_data[0][1];
    $fiok_data[3]=$fi_data[0][2];
    $fiok_data[4]=$fi_data[0][3];
    $fiok_data[5]=$fi_data[0][4];
    $fiok_data[6]=$fi_data[0][5];
    $fiok_data[7]=$fi_data[0][6];
    $file_dialog->ok_button->signal_connect( "clicked", \&fileImportOK, \@fiok_data );

    $file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );
    $file_dialog->show();
    print "Import\n";
    return 0;
  }

sub fileSaveAs
  {
    my $file_dialog;
    $file_dialog = new Gtk2::FileSelection("Save subtitle");
    $file_dialog->complete( "*.sub" );
    $file_dialog->ok_button->signal_connect( "clicked", \&fileSaveOK, $file_dialog );
    $file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

    $file_dialog->show();
    return 0;
  }


sub closeWindow
  {
    my ($widget, $window) = @_;

    $window->destroy();

    return 0;
  }


sub shifting
  {
    my ($widget, @sdata) = @_;

    my $time =  $sdata[0][0]->value; #$main::adj_time->value;
    my $start = $sdata[0][1]->value; #$main::adj_start->value;
    my $end = $sdata[0][2]->value; #$main::adj_end->value;
    my $line;

    my @rfdata;

    print "Shifting ;)\n";
    if ( ($main::filename) && ( $time != 0 ) ) {

      &cpMvSubFile();
      if ($time<0) {
	$time = -$time;
	$line = "./subshift.pl -t $time -s $start -e $end -i $main::filename -o $main::tmp_filename -d";
      } else {
	$line = "./subshift.pl -t $time -s $start -e $end -i $main::filename -o $main::tmp_filename";
      }
      print "$line\n";
      system($line);

      $main::filename = $main::tmp_filename;

      $rfdata[0]=$main::filename; #filename
      $rfdata[1]=$sdata[0][5]; #model
      $rfdata[2]=$sdata[0][6];
      $rfdata[3]=$sdata[0][7];

      &readFileToCList(\@rfdata);

      $sdata[0][3]->set_sensitive(1); #      $main::reread_item
      $sdata[0][4]->set_sensitive(1); #      $main::save_item->set_sensitive(1);

    }

    return 0;
  }

sub cpMvSubFile
  {
    if (($main::filename eq $main::tmp2_filename)) {
      system("mv $main::filename $main::tmp2_filename");
    } else {
      system("cp -R \"$main::filename\" $main::tmp2_filename");
    }

    $main::filename = $main::tmp2_filename;
  }

sub toStart
  {
    my ($widget, @tsdata) = @_;

    my $text_start;

    my $treeview = $tsdata[0][0];
    my $a_start = $tsdata[0][1];
    my $model = $treeview->get_model;
    my $selection = $treeview->get_selection;
    my $iter = $selection->get_selected;

    if ($iter) {
      my $path = $model->get_path ($iter);
      my $i = ($path->get_indices)[0];
      $text_start=$main::subtitles[$i]{start};
    }

    $a_start->set_value($text_start);#    $main::adj_start->set_value($main::text_start);
    return 0;
  }

sub toEnd
  {
    my ($widget, @tedata) = @_;

    my $text_end;

    my $treeview = $tedata[0][0];
    my $a_end = $tedata[0][1];
    my $model = $treeview->get_model;
    my $selection = $treeview->get_selection;
    my $iter = $selection->get_selected;

    if ($iter) {
      my $path = $model->get_path ($iter);
      my $i = ($path->get_indices)[0];
      $text_end=$main::subtitles[$i]{end};
    }

    $a_end->set_value( $text_end );#    $main::adj_end->set_value( $main::text_end);
    return 0;
  }

sub convertFPS
  {
    my ($widget, @cfps_data) = @_;

    my @rfdata;
    my $line;
    my $ofps = $cfps_data[0][0]->get_value();  #$main::spin_ofps->get_value();
    my $nfps = $cfps_data[0][1]->get_value();  #$main::spin_nfps->get_value();

    &cpMvSubFile();

    $line = "./setsubfps.pl -f $ofps -n $nfps -i $main::filename -o $main::tmp_filename";

    print "$line\n";
    system($line);

    $main::filename = $main::tmp_filename;

    $rfdata[0]=$main::filename; #filename
    $rfdata[1]=$cfps_data[0][4]; #model
    $rfdata[2]=$cfps_data[0][5];
    $rfdata[3]=$cfps_data[0][6];

    &readFileToCList(\@rfdata);

    $cfps_data[0][2]->set_sensitive(1);#    $reread_item->set_sensitive(1);
    $cfps_data[0][3]->set_sensitive(1);#    $save_item->set_sensitive(1);
    return 0;
  }

sub FPS
  {
    my ( $widget, @data ) = @_;

    $data[0][1]->set_value($data[0][0]); #    $main::spin_ofps->set_value(*spin);
    return 0;

  }

# Applies changes in list to tmpfile
sub applyEditSubtitle
  {

    my ( $widget, @apply_data ) = @_;

    my @rfdata;

    my $menuitem_file_saveas=$apply_data[0][3];
    my $menuitem_file_reload=$apply_data[0][4];
    my $start;
    my $end;
    my $text;
    my $line="";
    my $oldout;

    open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";

    #next should write to the file
    &cpMvSubFile();

    open STDOUT, ">$main::tmp_filename" or die("Couldn't open $main::tmp_filename\n") ;

    for my $row (0..$main::lines-1) {
      $start = $main::subtitles[$row]{start};
      $end = $main::subtitles[$row]{end};
      $text = $main::subtitles[$row]{subtitle};
      $line = "{$start}{$end}$text";
      print "$line\r\n";
    }

    close STDOUT;
    open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";

    $main::filename = $main::tmp_filename;

    $rfdata[0]=$main::filename; #filename
    $rfdata[1]=$apply_data[0][0]; #model
    $rfdata[2]=$apply_data[0][1];
    $rfdata[3]=$apply_data[0][2];

    &readFileToCList(\@rfdata);

    $menuitem_file_saveas->set_sensitive(1);
    $menuitem_file_reload->set_sensitive(1);
    $widget->set_sensitive(0);


  }



# Edit menuitems

sub editJoinOK
  {
    my ($widget, @fjok_data) = @_;

    # get last subtitle item from menu
    my $stime;
    my @rftcl_data;

    my $file_dialog=$fjok_data[0][0];

    # gots selected file
    my $join_filename = $file_dialog->get_filename();

    $file_dialog->destroy();
    $stime = $main::subtitles[ ($main::lines-1) ]{end} + 10; # add ten frames after last frame

    system("cp -R \"$join_filename\" $main::tmp2_filename");
    system("cp -R \"$main::filename\" \"$main::tmp_filename\"");
    print "cp -R \"$main::filename\" \"$main::tmp_filename\"";
    my $line = "./subshift.pl -t $stime -s 0 -e 0 -i $main::tmp2_filename -o $main::tmp3_filename\n";
    system($line);
    print "$line\n";
    system("cat $main::tmp3_filename >> $main::tmp_filename");

    $main::orig_filename = $main::filename;
    $main::filename = $main::tmp_filename;

    $rftcl_data[0]=$main::filename;
    $rftcl_data[1]=$fjok_data[0][2];
    $rftcl_data[2]=$fjok_data[0][3];
    $rftcl_data[3]=$fjok_data[0][4];
    &readFileToCList(\@rftcl_data);
    return 0;
  }

sub editJoin
  {
    my ($widget, @fj_data) = @_;

    my @fjok_data;
    my $file_dialog;
    print "Join start\n";
    $file_dialog = new Gtk2::FileSelection("Select subtitle to join");
    $file_dialog->complete( "*.sub" );

    print "Join m1\n";

    $fjok_data[0]=$file_dialog;
    $fjok_data[1]=$fj_data[0][0];
    $fjok_data[2]=$fj_data[0][1];
    $fjok_data[3]=$fj_data[0][2];
    $fjok_data[4]=$fj_data[0][3];
    $fjok_data[5]=$fj_data[0][4];

    print "Join m2\n";

    $file_dialog->ok_button->signal_connect( "clicked", \&editJoinOK, \@fjok_data );
    $file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

    $file_dialog->show();
    print "Join end\n";

    return 0;
  }

# sets and save prefs
sub setPrefs
  {
    my ( $widget, @pdata ) = @_;

    my $prefs_window  = $pdata[0][0];
    my $prefs_check_mplayer  = $pdata[0][1];
    my $prefs_spin_import  = $pdata[0][2];
    my $import_item  = $pdata[0][3];

    $main::importfps = $prefs_spin_import->get_value();
    $main::use_mplayer = $prefs_check_mplayer->get_active;

    $prefs_window->destroy();
    &saveConfig();
    if ($main::use_mplayer) {
      $import_item->set_sensitive(1);
    } else {
      $import_item->set_sensitive(0);
    }
    return 0;
  }

sub editPreferences
  {
    my ($widget, $import_item) = @_;

    my $prefs_window;
    my $prefs_table;
    my $prefs_button_ok;
    my $prefs_button_c;
    my $prefs_text_import_fps;
    my $prefs_checkbox_mplayer;
    my @prefs_data;
    my $prefs_spin_import_fps;

    # creates about window
    $prefs_window = new Gtk2::Window("toplevel");

    $prefs_table = new Gtk2::Table(2,3);

    $prefs_button_ok = new Gtk2::Button("OK");
    $prefs_button_c = new Gtk2::Button("Cancel");
	
    $prefs_checkbox_mplayer = new Gtk2::CheckButton("MPlayer installed (required for importing)");
    $prefs_text_import_fps = new Gtk2::Label("Import FPS:");

    #	$prefs_radio_mplayer = new Gtk2::Label("MPlayer intalled:");
    $main::prefs_adj_import_fps = new Gtk2::Adjustment( 0,
							1.0,
							100,
							0.1,
							1,
							10 );

    $prefs_spin_import_fps = new Gtk2::SpinButton($main::prefs_adj_import_fps, 1.0, 3);

    $prefs_window->set_title("Prefs GTKSubEditor $main::version");
    $prefs_window->set_default_size(250,70);

    $prefs_window->signal_connect( "delete_event", sub {$prefs_window->destroy();} );
    $prefs_button_c->signal_connect( "clicked", \&closeWindow, $prefs_window );

    $prefs_data[0] = $prefs_window;
    $prefs_data[1] = $prefs_checkbox_mplayer;
    $prefs_data[2] = $prefs_spin_import_fps;
    $prefs_data[3] = $import_item;
    $prefs_button_ok->signal_connect( "clicked", \&setPrefs, \@prefs_data); #$prefs_window);

    $prefs_table->attach_defaults( $prefs_checkbox_mplayer, 1, 2 , 0, 1 );

    $prefs_table->attach_defaults( $prefs_text_import_fps, 0, 1 , 1, 2 );
    $prefs_table->attach_defaults( $prefs_spin_import_fps, 1, 2 , 1, 2 );

    $prefs_table->attach_defaults( $prefs_button_ok, 0, 1 , 2, 3 );
    $prefs_table->attach_defaults( $prefs_button_c, 1, 2 , 2, 3 );
    $prefs_table->set_border_width(4);

    $prefs_button_c->set_border_width(4);
    #	$prefs_button_ok->show();
    $prefs_button_ok->set_border_width(4);

    $prefs_spin_import_fps->show();
    $prefs_spin_import_fps->set_value($main::importfps);
	
    if ($main::use_mplayer==1) {
      $prefs_checkbox_mplayer->set_active(1);
    } else {
      $prefs_checkbox_mplayer->set_active(0);
    }
    $prefs_window->set_modal( 1 );
    $prefs_window->add($prefs_table);

    $prefs_window->show_all();
    return 0;
  }


# Splitting
sub splitSaveOK
{
  my ( $widget, @split_ok_data ) = @_;

  my $file_dialog = $split_ok_data[0][0];
  my $from = $split_ok_data[0][1];
  my $to = $split_ok_data[0][2];
  my $shift = $split_ok_data[0][3];

  my $i=0;
  my $j=0;

  my $start=0;
  my $end=0;

  my $line;
  my $oldout;

  $main::filename = $file_dialog->get_filename();
  $file_dialog->destroy();

  # Save subtitle file from frame to
  # from
  while ( $from > $main::subtitles[$i]{start} )
    {
      $i++;
    }

  # to
  if( $to==0 )
    {
      $shift = $shift - $main::subtitles[$i]{start};
      $j=$main::lines;
    }
  else
    {
      while ( $to > $main::subtitles[$j]{start} )
	{
	  $j++;
	}
    }

  #write
  # open sdt to writing
  open $oldout, ">&STDOUT" or die "Can't duplicate STDOUT: $!";
  open STDOUT, ">$main::filename" or die("Couldn't open $main::filename\n");

  while ( ($i < $j) )
    {
      $start = $main::subtitles[$i]{start} + $shift;
      $end = $main::subtitles[$i]{end} + $shift;
      $line = "{$start}{$end}$main::subtitles[$i]{subtitle}\r\n";
      print "$line";
      $i++;
    }
  #close std from writing
  close STDOUT;
  open STDOUT, ">&", $oldout or die "Can't restore old STDOUT: $!";

  return 0;

}

sub splitSaveBegin
{
  my ( $widget, @split_data ) = @_;

    my @split_ok_data;
    my $file_dialog;
    my $to = $split_data[0][0]->get_value();

    $file_dialog = new Gtk2::FileSelection("Save subtitle begin");
    $file_dialog->complete( "*.sub" );

    $split_ok_data[0]=$file_dialog;
    $split_ok_data[1]=0; #from
    $split_ok_data[2]=$to; #to
    $split_ok_data[3]=0; #to

    $file_dialog->ok_button->signal_connect( "clicked", \&splitSaveOK, \@split_ok_data );
    $file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

    $file_dialog->show();

  return 0;
}

sub splitSaveEnd
{
  my ( $widget, @split_data ) = @_;

    my @split_ok_data;
    my $file_dialog;
    my $from = $split_data[0][0]->get_value();
    my $shift = $split_data[0][1]->get_value();

    $file_dialog = new Gtk2::FileSelection("Save subtitle end");
    $file_dialog->complete( "*.sub" );

    $split_ok_data[0]=$file_dialog;
    $split_ok_data[1]=$from; #from
    $split_ok_data[2]=0; #to
    $split_ok_data[3]=$shift; #to

    $file_dialog->ok_button->signal_connect( "clicked", \&splitSaveOK, \@split_ok_data );
    $file_dialog->cancel_button->signal_connect( "clicked", \&fileC, $file_dialog );

    $file_dialog->show();

  return 0;
}

1;
